{{
***************************************************
* File jvmVpQueue: VP queu (runs in seperate COG) *
***************************************************
}}

{{
  Virtual Peripherals are implemented as background code, meaning the code executes
  independantly from the interpreted java code.
}}


OBJ
  def: "jvmDefines"


DAT
  vpBank long 0

  
PUB start(vpRam) | bank,slot,type,head,tail,buffer,count,data,hsMask,hsInvert,hsInput,len
{{ run queue routine in seperate cog }}
  vpBank := vpRam
  slot := 0
  repeat
    bank := slot*24 + vpBank
    type := byte[bank + def#nmPeriphISRVec]
    slot := (slot+1) // def#MAX_NUM_VPS
    case type
      def#UARTRX: 'if received a byte, read value from receiver, and if queue not full enqueue value into queue
                  data := word[bank + def#nmUartDataH]
                  if data > 255
                    word[bank + def#nmUartDataH] := data & $FF 'clear rxflag
                    head := byte[bank + def#nmUartHead]
                    tail := byte[bank + def#nmUartTail]
                    buffer := word[bank + def#nmUartBufferH]
                    len := (head-tail+256) // 256
                    if len < 255
                      byte[buffer + head] := data
                      byte[bank + def#nmUartHead] := (head+1)
                     
      def#UARTTX: 'if allowed to transmit, and queue not empty, dequeue value from queue and write to transmitter
                  count := byte[bank + def#nmUartCount]
                  if count == 0
                    head := byte[bank + def#nmUartHead]
                    tail := byte[bank + def#nmUartTail]
                    buffer := word[bank + def#nmUartBufferH]
                    if head <> tail
                      hsMask := long[bank + def#nmInmask]
                      if hsMask <> 0
                        hsInvert := byte[bank + def#nmUartInvert] & $02
                        hsInput := ina & hsMask
                        if hsInvert == $02
                          hsInput ^= hsMask 'hsInput is 0 if handshake active (allowed to send)
                        hsMask := hsInput
                      if hsMask == 0  
                        data := byte[buffer + tail]
                        byte[bank + def#nmUartTail] := (tail+1)
                        data <<= 8
                        data |= $80
                        word[bank + def#nmUartDataH] := data
                        count := byte[bank + def#nmUartStopBits]
                        byte[bank + def#nmUartCount] := count

  